Package: BufferedMatrix
Version: 1.76.0
Title: A matrix data storage object held in temporary files
Author: Ben Bolstad <bmb@bmbolstad.com>
Maintainer: Ben Bolstad <bmb@bmbolstad.com>
Depends: R (>= 2.6.0), methods
Description: A tabular style data object where most data is stored outside main memory. A buffer is used to speed up access to data.
License: LGPL (>= 2)
URL: https://github.com/bmbolstad/BufferedMatrix
Collate: allGenerics.R BufferedMatrix.R as.BufferedMatrix.R
        createBufferedMatrix.R
LazyLoad: yes
biocViews: Infrastructure
git_url: https://git.bioconductor.org/packages/BufferedMatrix
git_branch: RELEASE_3_23
git_last_commit: 9d72964
git_last_commit_date: 2026-04-28
Repository: Bioconductor 3.23
Date/Publication: 2026-04-28
NeedsCompilation: yes
Packaged: 2026-04-28 20:59:10 UTC; biocbuild

##
##
## file: as.BufferedMatrix.R
##
## Aim: coerce an ordinary R matrix (or vector) to be a buffered.matrix.
## Aim: check whether object is a BufferedMatrix
## 
## Oct 3, 2006 - make as.BufferedMatrix call the C version
## Oct 6, 2006 - allow directory information to be passed into the function, allong with buffer size
## Jan 5, 2006 - fix as.BufferedMatrix. Incorrect parameters being passed to createBufferedMatrix


as.BufferedMatrix <- function(x,bufferrows=1, buffercols=1,directory=getwd()){


  if (!(is.matrix(x) | is.vector(x))){
    stop("Can't coerce this object to BufferedMatrix")
  }


  if ((storage.mode(x) != "double") & (storage.mode(x) != "integer")){
    stop("Can only coerce numeric matrices to BufferedMatrix storage")
  }


  if (is.matrix(x)){
    newBufferedMatrix <- createBufferedMatrix(rows=dim(x)[1],cols=dim(x)[2],bufferrows=bufferrows, buffercols=buffercols,directory=directory)

    if (storage.mode(x) == "double"){

      .Call("R_bm_as_BufferedMatrix",newBufferedMatrix@rawBufferedMatrix,x,PACKAGE="BufferedMatrix")
      
    } else if (storage.mode(x) == "integer"){
      for (col in 1:dim(x)[2]){
        newBufferedMatrix[,col] <- as.double(x[,col])
      }
    }
  } else if (is.vector(x)){
    newBufferedMatrix <- createBufferedMatrix(length(x),1)

    if (storage.mode(x) == "double"){
      newBufferedMatrix[,1] <- x
    } else if (storage.mode(x) == "integer"){
      newBufferedMatrix[,1] <- as.double(x)
    }

    


  }
  newBufferedMatrix

}



is.BufferedMatrix <- function(x){


  if (class(x) == "BufferedMatrix"){
    .Call("isBufferedMatrix",x@rawBufferedMatrix,PACKAGE="BufferedMatrix");
  } else {
    return(FALSE)
  }
}

## 
## file: BufferedMatrix.R
##
## Aim: define the BufferedMatrix S4 class and
##      and applicable methods
##
## History
## Feb 3, 2006 - Initial version
## Feb 7, 2006 - indexing/subsetting operators for accessing and replacing parts of the matrix
## Feb 8, 2006 - show method, nrow, ncol, is.ColMode, is.RowMode, ColMode, RowMode 
## Feb 16, 2006 - duplicate method, prefix method, directory method
## Feb 17, 2006 - ewApply method
## Feb 22, 2006 - add Max, Min, mean, Sd, Var methods. Also rowMeans,rowSums,colMeans,colSums
## Feb 23, 2006 - added rowVar, rowSd, colVar, colSd, rowMax, colMax, rowMin, colMin methods
## Apr 26, 2006 - add colApply
## May 30, 2006 - add subBufferedMatrix
## June 9, 2006 - add rownames and colnames with accessors and replacement functions
##                also allow some subsetting/indexing using these.
## June 12, 2006 - add dimnames accessors and replacement functions
## June 29, 2006 - add ReadOnly and is.ReadOnly (which inexplicably had the C code done
##                 but were never had methods implemented)
## Oct 21, 2006  - add colMedians
## Oct 22, 2006  - add colRanges
## Oct 27, 2006  - add filenames method, memory.usage method
## Jan 4, 2007   - remove isGeneric/setGeneric idiom. setGeneric's have been moved to their own file
## Jun 16, 2007 - add MoveStorageDirectory

setClass("BufferedMatrix",
           representation(rawBufferedMatrix="externalptr",rownames="character",colnames="character"),
           prototype=list(rownames=character(0),colnames=character(0)))




setMethod("dim", "BufferedMatrix", function(x){
          .Call("R_bm_getSize",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")
          })



setMethod("buffer.dim", "BufferedMatrix", function(x){
          .Call("R_bm_getBufferSize",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")
          })


setMethod("[", "BufferedMatrix", function(x, i, j,..., drop=FALSE) {


  if (!missing(i)){
    if (is.character(i)){
      which.i <- match(i,x@rownames)
      which.i <- which.i[!is.na(which.i)]
      if (length(which.i) == 0){
        stop("subscript out of bounds")
      } else {
        i <- which.i
      }
    } else if (is.logical(i)){
      if (length(i) != dim(x)[1]){
        stop("Incorrect length logical indexing vector should match number of rows.")
      }
      i <- which(i)
    }
  }

  
  if (!missing(j)){
    if (is.character(j)){
      which.j <- match(j,x@colnames)
      which.j <- which.j[!is.na(which.j)]
      if (length(which.j) == 0){
        stop("subscript out of bounds")
      } else {
        j <- which.j
      }
    } else if (is.logical(j)){
      if (length(j) != dim(x)[2]){
        stop("Incorrect length logical indexing vector should match number of columns.")
      }
      j <- which(j)
    }
  }

  


  
  ## indexing a single cell or submatrix
  if( !missing(i) & !missing(j)) {
    if ((length(i) == 1 & all(i > 0)) & (length(j) ==1 & all(j > 0))){
      ##single element
      dim.x <- dim(x)
      if ((abs(i) < 1) | (abs(i) > dim.x[1]) | (abs(j) < 1) | (abs(j) > dim.x[2])){
        stop("subscript out of bounds")
      }

      if ((i > 0) & (j >0)){
        return(.Call("R_bm_getValue",x@rawBufferedMatrix,as.integer(i-1),as.integer(j-1),PACKAGE="BufferedMatrix"))
      } else {
        ## at least one of i and j is negative
        ##
        indices.row <- (1:dim.x[1])[i]
        indices.col <- (1:dim.x[2])[j]
        return(.Call("R_bm_getValueSubmatrix",x@rawBufferedMatrix,as.integer(indices.row-1),as.integer(indices.col-1),PACKAGE="BufferedMatrix"))
      }
    } else {
      ##multiple elements
      dim.x <- dim(x)
      
      if (any(abs(i) < 1) | any(abs(i) > dim.x[1]) | any(abs(j) < 1) | any(abs(j) > dim.x[2])){
        stop("subscript out of bounds")
      }
      indices.row <- (1:dim.x[1])[i]
      indices.col <- (1:dim.x[2])[j]
      result <- .Call("R_bm_getValueSubmatrix",x@rawBufferedMatrix,as.integer(indices.row-1),as.integer(indices.col-1),PACKAGE="BufferedMatrix")
      rownames(result) <- rownames(x)[indices.row]
      colnames(result) <- colnames(x)[indices.col]
      return(result)
    }

    
  }

  ## indexing a row or set of rows
  if( !missing(i) & missing(j)) {
    dim.x <- dim(x)
    if (any(abs(i) < 1) | any(abs(i) > dim.x[1])){
      stop("subscript out of bounds")
    }
    if (any(i < 0) & !all(i <0)){
      stop("can't mix positive and negative indices")
    }
    if (all(i <0)){
      indices <- (1:dim.x[1])[i]

      result <- .Call("R_bm_getValueRow",x@rawBufferedMatrix,as.integer(indices-1),PACKAGE="BufferedMatrix")
      colnames(result) <- colnames(x)
      rownames(result) <- rownames(x)[indices]
      return(result)
    } else {
      result <- .Call("R_bm_getValueRow",x@rawBufferedMatrix,as.integer(i-1),PACKAGE="BufferedMatrix")
      colnames(result) <- colnames(x)
      rownames(result) <- rownames(x)[i]
      return(result)
    }
  }


  ## indexing a column or set of columns
  if( !missing(j) & missing(i)) {
    dim.x <- dim(x)
    if (any(abs(j) < 1) | any(abs(j) > dim.x[2])){
      stop("subscript out of bounds")
    }
    if (any(j < 0) & !all(j <0)){
      stop("can't mix positive and negative indices")
    }
    if (all(j <0)){
      indices <- (1:dim.x[2])[j]
      result <- .Call("R_bm_getValueColumn",x@rawBufferedMatrix,as.integer(indices-1),PACKAGE="BufferedMatrix")
      rownames(result) <- rownames(x)
      colnames(result) <- colnames(x)[indices]
      return(result)
    } else {
      result <-.Call("R_bm_getValueColumn",x@rawBufferedMatrix,as.integer(j-1),PACKAGE="BufferedMatrix")
      rownames(result) <- rownames(x)
      colnames(result) <- colnames(x)[j]
      return(result)
    }
  }

  

  return(x)
})



setReplaceMethod("[", "BufferedMatrix", function(x, i, j,..., value){


  # how many copies of value are needed to fill column-wise of size rows
  recycle.how.many.columns <- function(value,columns,rows){
    if (is.vector(value)){
      length.value <- length(value)     
    } else if (is.matrix(value)) {
      dim.value <- dim(value)
      length.value <- dim.value[1]*dim.value[2]
    }
    
    
    if (length.value < rows){
      if ((columns*rows) %% length.value == 0){
        return ((columns*rows) %/% length.value)
      } else {
        stop("number of items to replace is not a multiple of replacement length")
      }
      
    } else if (length.value > rows){
      if (length.value > rows *columns){
        stop("number of items to replace is not a multiple of replacement length")
      }
      if (length.value %% (columns*rows) == 0){
        return ((length.value) %/%(columns*rows)) 
      } else if ((rows*columns) %% length.value == 0){
        return ((columns*rows)%/%(length.value) )
      } else {
        stop("number of items to replace is not a multiple of replacement length")
      }
      
    } else {
      return ((length.value*columns) %/%(rows))
    } 
    
    
    
    
  }

  if (is.ReadOnlyMode(x)){
    stop("BufferedMatrix is ReadOnly.")
  }


  if (!is.double(value)){
    value <- as.double(value)
  }

  
  if (!missing(i)){
    if (is.character(i)){
      which.i <- match(i,x@rownames)
      which.i <- which.i[!is.na(which.i)]
      if (length(which.i) == 0){
        stop("subscript out of bounds")
      } else {
        i <- which.i
      }
    } else if (is.logical(i)){
      if (length(i) != dim(x)[1]){
        stop("Incorrect length logical indexing vector should match number of rows.")
      }
      i <- which(i)
    }
  }

  
  if (!missing(j)){
    if (is.character(j)){
      which.j <- match(j,x@colnames)
      which.j <- which.j[!is.na(which.j)]
      if (length(which.j) == 0){
        stop("subscript out of bounds")
      } else {
        j <- which.j
      }
    } else if (is.logical(j)){
      if (length(j) != dim(x)[2]){
        stop("Incorrect length logical indexing vector should match number of columns.")
      }
      j <- which(j)
    }
  }

  

  
  if( !missing(i) & !missing(j)) {
    if ((length(i) == 1) & (length(j) ==1)){
      ##single element
      dim.x <- dim(x)
      if ((abs(i) < 1) | (abs(i) > dim.x[1]) | (abs(j) < 1) | (abs(j) > dim.x[2])){
        stop("subscript out of bounds")
      }
      if (i > 0 & j > 0){
        value <- rep(value,recycle.how.many.columns(value,1,1))
        .Call("R_bm_setValue",x@rawBufferedMatrix,as.integer(i-1),as.integer(j-1),value,PACKAGE="BufferedMatrix")
      } else {
        indices.row <- (1:dim.x[1])[i]
        indices.col <- (1:dim.x[2])[j]
        value <- rep(value,recycle.how.many.columns(value,length(indices.col),length(indices.row)))
        .Call("R_bm_setValueSubmatrix",x@rawBufferedMatrix,as.integer(indices.row-1),as.integer(indices.col-1),value,PACKAGE="BufferedMatrix")
      }
    }else {
      dim.x <- dim(x)
      indices.row <- (1:dim.x[1])[i]
      indices.col <- (1:dim.x[2])[j]
      value <- rep(value,recycle.how.many.columns(value,length(indices.col),length(indices.row)))
      .Call("R_bm_setValueSubmatrix",x@rawBufferedMatrix,as.integer(indices.row-1),as.integer(indices.col-1),value,PACKAGE="BufferedMatrix")
    }
  }



  ## replacing a row or set of rows
  if( !missing(i) & missing(j)) {
    dim.x <- dim(x)

    if (any(abs(i) < 1) | any(abs(i) > dim.x[1])){
      stop("subscript out of bounds")
    }
    if (any(i < 0) & !all(i <0)){
      stop("can't mix positive and negative indices")
    }

    if (all(i < 0)){
      indices <- (1:dim.x[1])[i]
      value <- rep(value,recycle.how.many.columns(value,dim.x[2],length(indices)))
      .Call("R_bm_setValueRow",x@rawBufferedMatrix,as.integer(indices-1),value,PACKAGE="BufferedMatrix")
    } else {
      value <- rep(value,recycle.how.many.columns(value,dim.x[2],length(i)))
      .Call("R_bm_setValueRow",x@rawBufferedMatrix,as.integer(i-1),value,PACKAGE="BufferedMatrix")
    }

    
  }


  ## replacing a column or set of columns
  if( !missing(j) & missing(i)) {
    dim.x <- dim(x)
    if (any(abs(j) < 1) | any(abs(j) > dim.x[2])){
      stop("subscript out of bounds")
    }
    if (any(j < 0) & !all(j <0)){
      stop("can't mix positive and negative indices")
    }
    if (all(j <0)){
      indices <- (1:dim.x[2])[j]
      value <- rep(value,recycle.how.many.columns(value,length(indices),dim.x[1]))
      .Call("R_bm_setValueColumn",x@rawBufferedMatrix,as.integer(indices-1),value,PACKAGE="BufferedMatrix")
    } else {
      value <- rep(value,recycle.how.many.columns(value,length(j),dim.x[1]))
      .Call("R_bm_setValueColumn",x@rawBufferedMatrix,as.integer(j-1),value,PACKAGE="BufferedMatrix")
    }
  }
  return(x)
  

})




setMethod("show", "BufferedMatrix", function(object){

  cat("BufferedMatrix object\n")
  cat("Matrix size: ",dim(object),"\n")
  cat("Buffer size: ",buffer.dim(object),"\n")
  cat("Directory:   ",directory(object),"\n")
  cat("Prefix:      ",prefix(object),"\n")
  cat("Mode: ");
  if (is.RowMode(object)){
    cat("Row mode\n")
  } else {
    cat("Col mode\n")
  }
  cat("Read Only: ")
  cat(is.ReadOnlyMode(object))
  cat("\n")

  mem.usage <- memory.usage(object)

  if (mem.usage < 1024){
    cat("Memory usage : ",mem.usage," bytes.\n")
  } else if (mem.usage < 1024^2) {
    cat("Memory usage : ",round(mem.usage/1024,1)," Kilobytes.\n")
  } else {
    cat("Memory usage : ",round(mem.usage/1024^2,2)," Megabytes.\n")
  }
  
  disk.space.used <- disk.usage(object)
  if (disk.space.used < 1024){
    cat("Disk usage : ",disk.space.used," bytes.\n")
  } else if (mem.usage < 1024^2) {
    cat("Disk usage : ",round(disk.space.used/1024,1)," Kilobytes.\n")
  } else {
    cat("Disk usage : ",round(disk.space.used/1024^2,2)," Megabytes.\n")
  }

  


  
})



setMethod("ncol","BufferedMatrix",function(x){
  dim(x)[2]
})


setMethod("nrow","BufferedMatrix",function(x){
  dim(x)[1]
})




setMethod("is.ColMode","BufferedMatrix",function(x){

  return(!.Call("R_bm_isRowMode",x@rawBufferedMatrix,PACKAGE="BufferedMatrix"))

})


setMethod("is.RowMode","BufferedMatrix",function(x){

  return(.Call("R_bm_isRowMode",x@rawBufferedMatrix,PACKAGE="BufferedMatrix"))

})



setMethod("RowMode","BufferedMatrix",function(x){
  return(.Call("R_bm_RowMode",x@rawBufferedMatrix,PACKAGE="BufferedMatrix"))

})



setMethod("ColMode","BufferedMatrix",function(x){
  return(.Call("R_bm_ColMode",x@rawBufferedMatrix,PACKAGE="BufferedMatrix"))

})





setMethod("set.buffer.dim", "BufferedMatrix", function(x,rows,cols){
          .Call("R_bm_ResizeBuffer",x@rawBufferedMatrix,rows,cols,PACKAGE="BufferedMatrix")
          })



setMethod("prefix","BufferedMatrix",function(x){
  .Call("R_bm_getPrefix",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")

  
})



setMethod("directory","BufferedMatrix",function(x){
  .Call("R_bm_getDirectory",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")

  
})




setMethod("filenames","BufferedMatrix",function(x){
  .Call("R_bm_getFileNames",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")
})




setMethod("duplicate", "BufferedMatrix", function(x,prefix="BM",dir) {

  bufferrows <- buffer.dim(x)[1]
  buffercols <- buffer.dim(x)[2]
  rows <- nrow(x)
  cols <- ncol(x)
  

  
  if (missing(dir)){
    my.directory <- directory(x)
  } else {
    my.directory <- dir
  }

  if (missing(prefix)){
    my.prefix <- prefix(x)
  } else {
    my.prefix <-prefix
  }

  
  
  tmp.externpointer<- .Call("R_bm_Create",my.prefix,my.directory,bufferrows,buffercols, PACKAGE="BufferedMatrix")

  .Call("R_bm_setRows",tmp.externpointer,rows, PACKAGE="BufferedMatrix")

  if (cols > 0){
    for (i in 1:cols){
      .Call("R_bm_AddColumn",tmp.externpointer, PACKAGE="BufferedMatrix")
    }
  }
  if(!.Call("R_bm_copyValues",tmp.externpointer, x@rawBufferedMatrix, PACKAGE="BufferedMatrix")){
    stop("Duplication failed in data copying stage\n");
  }
  
  y <- new("BufferedMatrix",rawBufferedMatrix=tmp.externpointer)

  return(y)

  
})


setMethod("ewApply", "BufferedMatrix", function(x,FUN,...){


  if (is.ReadOnlyMode(x)){
    stop("BufferedMatrix is ReadOnly.")
  }
  

  
  if (missing(FUN)){
    stop("Must provide function to apply.")
  }

  FUN <- match.fun(FUN)


  fc <- function(x) {
    x <- FUN(x,...)
    if (!is.numeric(x)) stop("Need numeric result")
    as.double(x)
  }
  

  check.function.return.length <- function(){
    if (length(fc(c(1))) != 1){
      return(FALSE)
    }
    if (length(fc(c(1,2,3))) != 3){
      return(FALSE)
    }
    return(TRUE)
  }
  

  if (!check.function.return.length()){
    stop("This function should return a vector of same length as input. Cannot apply elementwise")

  }
  
  if(!.Call("R_bm_ewApply", x@rawBufferedMatrix,body(fc), new.env(), PACKAGE="BufferedMatrix")){
    stop("Problem applying function elementwise")
  }
  
  return(x)
})





setMethod("sqrt","BufferedMatrix",function(x){

  if (is.ReadOnlyMode(x)){
    stop("BufferedMatrix is ReadOnly.")
  }

  return(invisible(.Call("R_bm_ewSqrt",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")))
  
})


setMethod("exp","BufferedMatrix",function(x){

  if (is.ReadOnlyMode(x)){
    stop("BufferedMatrix is ReadOnly.")
  }
  
  
  return(invisible(.Call("R_bm_ewExp",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")))
})


setMethod("log","BufferedMatrix",function(x,base = exp(1)){

  if (is.ReadOnlyMode(x)){
    stop("BufferedMatrix is ReadOnly.")
  }
  
  return(invisible(.Call("R_bm_ewLog",x@rawBufferedMatrix,base,PACKAGE="BufferedMatrix")))
})



setMethod("pow","BufferedMatrix",function(x,power=1){

  
  if (is.ReadOnlyMode(x)){
    stop("BufferedMatrix is ReadOnly.")
  }

  return(invisible(.Call("R_bm_ewPow",x@rawBufferedMatrix,power,PACKAGE="BufferedMatrix")))
})


setMethod("Max", signature("BufferedMatrix"), function(x,na.rm=FALSE){
  return(.Call("R_bm_max",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))
})


setMethod("Min", "BufferedMatrix", function(x,na.rm=FALSE){
  return(.Call("R_bm_min",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))
})


setMethod("mean", "BufferedMatrix", function(x,na.rm=FALSE){
  return(.Call("R_bm_mean",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))
})


setMethod("Sum","BufferedMatrix", function(x,na.rm=FALSE){
  return(.Call("R_bm_sum",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))
})


setMethod("Var", "BufferedMatrix", function(x,na.rm=FALSE){
  return(.Call("R_bm_var",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))
})


setMethod("Sd", "BufferedMatrix", function(x,na.rm=FALSE){
  sqrt(Var(x,na.rm))
})


setMethod("rowMeans","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_rowMeans",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))


})



setMethod("rowSums","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_rowSums",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))


})


setMethod("rowVars","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_rowVars",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))


})


setMethod("rowSd","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(sqrt(rowVars(x,na.rm,dims)))


})



setMethod("rowMax","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_rowMax",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))



})



setMethod("rowMin","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_rowMin",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))

})




setMethod("colMeans","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_colMeans",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))

})



setMethod("colSums","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_colSums",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))


})


setMethod("colVars","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_colVars",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))


})


setMethod("colSd","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(sqrt(colVars(x,na.rm,dims)))


})



setMethod("colMax","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_colMax",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))



})




setMethod("colMin","BufferedMatrix",function(x,na.rm=FALSE,dims=1){

  return(.Call("R_bm_colMin",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))



})


setMethod("colMedians","BufferedMatrix",function(x,na.rm=FALSE){

  return(.Call("R_bm_colMedians",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))



})

setMethod("colRanges","BufferedMatrix",function(x,na.rm=FALSE){

  return(.Call("R_bm_colRanges",x@rawBufferedMatrix,na.rm,FALSE,PACKAGE="BufferedMatrix"))



})



setMethod("colApply", "BufferedMatrix", function(x,FUN,...){

  if (missing(FUN)){
    stop("Must provide function to apply.")
  }

  FUN <- match.fun(FUN)


  fc <- function(x) {
    x <- FUN(x,...)
    if (!is.numeric(x)) stop("Need numeric result")
    as.double(x)
  }
  
  check.function.return.length <- function(){
    length(fc(x[,1]))
  }

  return.dim1 <- check.function.return.length()

  result <- .Call("R_bm_colApply", x@rawBufferedMatrix,return.dim1,body(fc), new.env(), PACKAGE="BufferedMatrix")

  if(!result[[1]]){
    stop("Problem applying function column wise")
  }
  if (return.dim1 ==1){
    return(do.call(c,result[[2]]))
  } else {
    return(new("BufferedMatrix",rawBufferedMatrix=result[[2]]))
  }
})




setMethod("rowApply", "BufferedMatrix", function(x,FUN,...){

  if (missing(FUN)){
    stop("Must provide function to apply.")
  }

  FUN <- match.fun(FUN)


  fc <- function(x) {
    x <- FUN(x,...)
    if (!is.numeric(x)) stop("Need numeric result")
    as.double(x)
  }
  
  check.function.return.length <- function(){
    length(fc(x[1,]))
  }

  return.dim1 <- check.function.return.length()

  result <- .Call("R_bm_rowApply", x@rawBufferedMatrix,return.dim1,body(fc), new.env(), PACKAGE="BufferedMatrix")

  if(!result[[1]]){
    stop("Problem applying function row wise")
  }
  if (return.dim1 ==1){
    return(do.call(c,result[[2]]))
  } else {
    return(new("BufferedMatrix",rawBufferedMatrix=result[[2]]))
  }
})


setMethod("as.matrix", "BufferedMatrix", function(x, ...){
  
  
  .Call("R_bm_as_matrix", x@rawBufferedMatrix, PACKAGE="BufferedMatrix")
  

})





setMethod("subBufferedMatrix","BufferedMatrix", function(x,i, j){


  ###
  ### i and j index rows and columns respectively
  ###
  ### Note this finds this data from the supplied buffered matrix
  ### and copies it into a new buffered matrix which it returns
  ###
  
  if (!missing(i)){
    if (is.character(i)){
      which.i <- match(i,x@rownames)
      which.i <- which.i[!is.na(which.i)]
      if (length(which.i) == 0){
        stop("subscript out of bounds")
      } else {
        i <- which.i
      }
    } else if (is.logical(i)){
      if (length(i)!= dim(x)[1]){
        stop("Incorrect length logical indexing vector should match number of columns.")
      }
      i <- which(i)
    }
  }

  
  if (!missing(j)){
    if (is.character(j)){
      which.j <- match(j,x@colnames)
      which.j <- which.j[!is.na(which.j)]
      if (length(which.j) == 0){
        stop("subscript out of bounds")
      } else {
        j <- which.j
      }
    } else if (is.logical(j)){
      if (length(j) != dim(x)[2]){
        stop("Incorrect length logical indexing vector should match number of columns.")
      }
      j <- which(j)
    }
  }

  
    ## indexing a single cell or submatrix
  if( !missing(i) & !missing(j)) {
    if ((length(i) == 1 & all(i > 0)) & (length(j) ==1 & all(j > 0))){
      ##single element
      dim.x <- dim(x)
      if ((abs(i) < 1) | (abs(i) > dim.x[1]) | (abs(j) < 1) | (abs(j) > dim.x[2])){
        stop("subscript out of bounds")
      }

      if ((i > 0) & (j >0)){
        if (!is.null(colnames(x))){
          this.colnames <-colnames(x)[i]
        } else {
          this.colnames <- character()
        }

        if (!is.null(rownames(x))){
          this.rownames <-rownames(x)[j]
        } else {
          this.rownames <- character()
        }
      
        return(new("BufferedMatrix",rawBufferedMatrix=.Call("R_bm_MakeSubmatrix",x@rawBufferedMatrix,as.integer(i-1),as.integer(j-1),PACKAGE="BufferedMatrix"),rownames=this.rownames,colnames= this.colnames))
      } else {
        ## at least one of i and j is negative
        ##
        indices.row <- (1:dim.x[1])[i]
        indices.col <- (1:dim.x[2])[j]

        if (!is.null(colnames(x))){
          this.colnames <-colnames(x)[indices.col]
        } else {
          this.colnames <- character()
        }

        if (!is.null(rownames(x))){
          this.rownames <-rownames(x)[indices.row]
        } else {
          this.rownames <- character()
        }
      
 
        return(new("BufferedMatrix",rawBufferedMatrix=.Call("R_bm_MakeSubmatrix",x@rawBufferedMatrix,as.integer(indices.row-1),as.integer(indices.col-1),PACKAGE="BufferedMatrix"),rownames=this.rownames,colnames= this.colnames))
      }
    } else {
      ##multiple elements
      dim.x <- dim(x)
      
      if (any(abs(i) < 1) | any(abs(i) > dim.x[1]) | any(abs(j) < 1) | any(abs(j) > dim.x[2])){
        stop("subscript out of bounds")
      }
      indices.row <- (1:dim.x[1])[i]
      indices.col <- (1:dim.x[2])[j]
     

      if (!is.null(colnames(x))){
        this.colnames <-colnames(x)[indices.col]
      } else {
        this.colnames <- character()
      }

      if (!is.null(rownames(x))){
        this.rownames <-rownames(x)[indices.row]
      } else {
        this.rownames <- character()
      }
      
      return(new("BufferedMatrix",rawBufferedMatrix=.Call("R_bm_MakeSubmatrix",x@rawBufferedMatrix,as.integer(indices.row-1),as.integer(indices.col-1),PACKAGE="BufferedMatrix"),rownames=this.rownames,colnames= this.colnames))
    }

    
  }

  ## indexing a row or set of rows
  if( !missing(i) & missing(j)) {
    dim.x <- dim(x)
    if (any(abs(i) < 1) | any(abs(i) > dim.x[1])){
      stop("subscript out of bounds")
    }
    if (any(i < 0) & !all(i <0)){
      stop("can't mix positive and negative indices")
    }
    if (all(i <0)){
      indices <- (1:dim.x[1])[i]

      
      if (!is.null(colnames(x))){
        this.colnames <-colnames(x)
      } else {
        this.colnames <- character()
      }

      if (!is.null(rownames(x))){
        this.rownames <-rownames(x)[indices]
      } else {
        this.rownames <- character()
      }
            
      return(new("BufferedMatrix",rawBufferedMatrix=.Call("R_bm_MakeSubmatrix",x@rawBufferedMatrix,as.integer(indices-1),as.integer(1:dim.x[2]-1),PACKAGE="BufferedMatrix"),rownames=this.rownames,colnames= this.colnames))
    } else {

      if (!is.null(colnames(x))){
        this.colnames <-colnames(x)
      } else {
        this.colnames <- character()
      }

      if (!is.null(rownames(x))){
        this.rownames <-rownames(x)[i]
      } else {
        this.rownames <- character()
      }
      

      
      return(new("BufferedMatrix",rawBufferedMatrix=.Call("R_bm_MakeSubmatrix",x@rawBufferedMatrix,as.integer(i-1),as.integer(1:dim.x[2]-1),PACKAGE="BufferedMatrix"),rownames=this.rownames,colnames= this.colnames))
    }
  }


  ## indexing a column or set of columns
  if( !missing(j) & missing(i)) {
    dim.x <- dim(x)
    if (any(abs(j) < 1) | any(abs(j) > dim.x[2])){
      stop("subscript out of bounds")
    }
    if (any(j < 0) & !all(j <0)){
      stop("can't mix positive and negative indices")
    }
    if (all(j <0)){
      indices <- (1:dim.x[2])[j]

      if (!is.null(colnames(x))){
        this.colnames <-colnames(x)[indices]
      } else {
        this.colnames <- character()
      }

      if (!is.null(rownames(x))){
        this.rownames <-rownames(x)
      } else {
        this.rownames <- character()
      }
      
      return(new("BufferedMatrix",rawBufferedMatrix=.Call("R_bm_MakeSubmatrix",x@rawBufferedMatrix,as.integer(1:dim.x[1]-1),as.integer(indices-1),PACKAGE="BufferedMatrix"),rownames=this.rownames,colnames= this.colnames))
    } else {

      if (!is.null(colnames(x))){
        this.colnames <-colnames(x)[j]
      } else {
        this.colnames <- character()
      }

      if (!is.null(rownames(x))){
        this.rownames <-rownames(x)
      } else {
        this.rownames <- character()
      }
      
      
      return(new("BufferedMatrix",rawBufferedMatrix=.Call("R_bm_MakeSubmatrix",x@rawBufferedMatrix,as.integer(1:dim.x[1]-1),as.integer(j-1),PACKAGE="BufferedMatrix"),rownames=this.rownames,colnames= this.colnames))
    }
  }


  

  
})





setMethod("rownames","BufferedMatrix",function(x,do.NULL=TRUE,prefix="row"){

  if (do.NULL)
    if (length(x@rownames) == 0){
      return(NULL)
    } else {
      return(x@rownames)
    }
  else
    paste(prefix, seq(length = nrow(x)), sep = "")
  
})


setMethod("colnames","BufferedMatrix",function(x,do.NULL=TRUE,prefix="col"){

  if (do.NULL)
    if (length(x@colnames) == 0){
      return(NULL)
    } else {
      return(x@colnames)
    }
  else
    paste(prefix, seq(length = ncol(x)), sep = "")
  
})




setReplaceMethod("colnames", "BufferedMatrix",function(x,value){

  if(!is.null(value)){
    value <- as.character(value)
    value <- as.character(value)

    if (ncol(x) == length(value)){
      x@colnames <- as.vector(value)
      x
    }
    else
      stop("Incorrect length for colnames")
  } else {
    x@colnames <- character()
    x
  }
})





setReplaceMethod("rownames", "BufferedMatrix",function(x,value){

  if(!is.null(value)){
    value <- as.character(value)

    if (nrow(x) == length(value)){
      x@rownames <- as.vector(value)
      x
    }
    else
      stop("Incorrect length for rownames")
  } else {
    x@rownames <- character()
    x

  }
})





setMethod("dimnames","BufferedMatrix",function(x){


  row.names <- rownames(x)
  col.names <- colnames(x)

  if (is.null(row.names) & is.null(col.names)){
    return(NULL)
  } else {
    return(list(row.names,col.names))

  }

  


})




setReplaceMethod("dimnames","BufferedMatrix",function(x,value){


  if (is.null(value)){
    rownames(x) <- NULL
    colnames(x) <- NULL
    return(x)
  } else  if (is.list(value) & (length(value) ==2)){
    rownames(x) <- value[[1]]
    colnames(x) <- value[[2]]
    return (x)
  } else {
    stop("Wrong length supplied to repalce dimnames")
  }

})




setMethod("ReadOnlyMode","BufferedMatrix",function(x){


  .Call("R_bm_ReadOnlyModeToggle",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")

})



setMethod("is.ReadOnlyMode","BufferedMatrix",function(x){


  .Call("R_bm_isReadOnlyMode",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")

})



setMethod("memory.usage","BufferedMatrix",function(x){

  .Call("R_bm_memoryInUse",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")
})



setMethod("disk.usage","BufferedMatrix",function(x){

  .Call("R_bm_fileSpaceInUse",x@rawBufferedMatrix,PACKAGE="BufferedMatrix")
})



setAs("BufferedMatrix", "matrix", function(from){
  as.matrix(from)
})


setAs("matrix", "BufferedMatrix", function(from){
  as.BufferedMatrix(from)
})



setMethod("AddColumn","BufferedMatrix",function(x){
   x@rawBufferedMatrix <- .Call("R_bm_AddColumn",x@rawBufferedMatrix, PACKAGE="BufferedMatrix")
   x
})


setMethod("MoveStorageDirectory","BufferedMatrix",function(x,new.directory,full.path=TRUE){

  if (full.path){
    dir.create(new.directory)
  } else {
    new.directory <- file.path(getwd(),new.directory)
    dir.create(new.directory)
  }

  .Call("R_bm_setNewDirectory",x@rawBufferedMatrix, new.directory, PACKAGE="BufferedMatrix")
})
      





setMethod("rowMedians","BufferedMatrix",function(x,na.rm=FALSE){

  return(.Call("R_bm_rowMedians",x@rawBufferedMatrix,na.rm,PACKAGE="BufferedMatrix"))



})

library(BufferedMatrix);library.dynam("BufferedMatrix","BufferedMatrix", .libPaths());

prefix <- "dbmtest"
directory <- getwd()


P <- .Call("R_bm_Create",prefix,directory,1,1)
.Call("R_bm_Test_C",P)
.Call("R_bm_Test_C2",P)
.Call("R_bm_Test_C",P)
.Call("R_bm_Test_C2",P)
rm(P)

#P <- .Call("R_bm_Destroy",P)
#.Call("R_bm_Destroy",P)
#.Call("R_bm_Test_C",P)


P <- .Call("R_bm_Create",prefix,directory,1,1)
.Call("R_bm_setRows",P,5)
.Call("R_bm_Test_C2",P)
.Call("R_bm_AddColumn",P)
.Call("R_bm_Test_C2",P)
.Call("R_bm_AddColumn",P)
.Call("R_bm_Test_C2",P)
rm(P)



P <- .Call("R_bm_Create",prefix,directory,1,1)
.Call("R_bm_setRows",P,5)
.Call("R_bm_AddColumn",P)
.Call("R_bm_AddColumn",P)
.Call("R_bm_Test_C2",P)

.Call("R_bm_ResizeBuffer",P,5,5)
.Call("R_bm_Test_C2",P)

.Call("R_bm_RowMode",P)
.Call("R_bm_Test_C2",P)

.Call("R_bm_ColMode",P)
.Call("R_bm_Test_C2",P)
rm(P)


P <- .Call("R_bm_Create",prefix,directory,1,1)
.Call("R_bm_setRows",P,10)
.Call("R_bm_AddColumn",P)
.Call("R_bm_SetPrefix",P,"BufferedMatrixFile")
.Call("R_bm_AddColumn",P)
.Call("R_bm_AddColumn",P)
dir(pattern="BufferedMatrixFile")
rm(P)
dir(pattern="BufferedMatrixFile")


P <- .Call("R_bm_Create",prefix,directory,1,1)
.Call("R_bm_setRows",P,10)
.Call("R_bm_AddColumn",P)
.Call("R_bm_AddColumn",P)
.Call("R_bm_ReadOnlyModeToggle",P)
.Call("R_bm_isReadOnlyMode",P)
.Call("R_bm_ReadOnlyModeToggle",P)
.Call("R_bm_isReadOnlyMode",P)
.Call("R_bm_isRowMode",P)
.Call("R_bm_RowMode",P)
.Call("R_bm_isRowMode",P)
.Call("R_bm_ColMode",P)
.Call("R_bm_isRowMode",P)
rm(P)


P <- .Call("R_bm_Create",prefix,directory,1,1)
.Call("R_bm_setRows",P,10)
.Call("R_bm_AddColumn",P)
.Call("R_bm_AddColumn",P)

.Call("R_bm_getSize",P)
.Call("R_bm_getBufferSize",P)
.Call("R_bm_ResizeBuffer",P,5,5)

.Call("R_bm_getBufferSize",P)
.Call("R_bm_ResizeBuffer",P,-1,5)
rm(P)


P <- .Call("R_bm_Create",prefix,directory,1,1)
.Call("R_bm_Test_C",P)
.Call("R_bm_getValue",P,3,3)

.Call("R_bm_getValue",P,100000,10000)
.Call("R_bm_setValue",P,3,3,12345.0)
.Call("R_bm_Test_C2",P)
rm(P)

## 
## file: createBufferedMatrix.R
##
## Aim: create a new BufferedMatrix
##
##
## History
## Feb 3, 2006 - Initial version
##


createBufferedMatrix <- function(rows, cols=0, bufferrows=1, buffercols=1,prefix="BM",directory=getwd()){

 
  
  tmp.externpointer<- .Call("R_bm_Create",prefix,directory,bufferrows,buffercols, PACKAGE="BufferedMatrix")
  
  .Call("R_bm_setRows",tmp.externpointer,rows, PACKAGE="BufferedMatrix")

  if (cols > 0){
    for (i in 1:cols){
      tmp.externpointer <- .Call("R_bm_AddColumn",tmp.externpointer, PACKAGE="BufferedMatrix")
    }
  }
  return(new("BufferedMatrix",rawBufferedMatrix=tmp.externpointer))
}

setGeneric("buffer.dim", function(x) standardGeneric("buffer.dim"))
setGeneric("is.ColMode", function(x) standardGeneric("is.ColMode"))
setGeneric("is.RowMode", function(x) standardGeneric("is.RowMode"))
setGeneric("RowMode", function(x) standardGeneric("RowMode"))
setGeneric("ColMode", function(x) standardGeneric("ColMode"))
setGeneric("set.buffer.dim", function(x,rows,cols) standardGeneric("set.buffer.dim"))
setGeneric("prefix", function(x) standardGeneric("prefix"))
setGeneric("directory", function(x) standardGeneric("directory"))
setGeneric("filenames",function(x) standardGeneric("filenames"))
setGeneric("duplicate", function(x,...) standardGeneric("duplicate"))
setGeneric("ewApply", function(x,...) standardGeneric("ewApply"))
setGeneric("pow", function(x,...) standardGeneric("pow"))
setGeneric("Max", function(x,...) standardGeneric("Max"))
setGeneric("Min", function(x,...) standardGeneric("Min"))
setGeneric("Sum", function(x,...) standardGeneric("Sum"))
setGeneric("Var", function(x,...) standardGeneric("Var"))
setGeneric("Sd", function(x,...) standardGeneric("Sd"))
setGeneric("rowMeans", function(x,na.rm = FALSE, dims = 1L,...) standardGeneric("rowMeans"))
setGeneric("rowSums", function(x,na.rm = FALSE, dims = 1L,...) standardGeneric("rowSums"))
setGeneric("rowVars", function(x,na.rm = FALSE, dims = 1) standardGeneric("rowVars"))
setGeneric("rowSd", function(x,na.rm = FALSE, dims = 1) standardGeneric("rowSd"))
setGeneric("rowMax", function(x,na.rm = FALSE, dims = 1) standardGeneric("rowMax"))
setGeneric("rowMin", function(x,na.rm = FALSE, dims = 1) standardGeneric("rowMin"))
setGeneric("rowMedians", function(x,na.rm = FALSE) standardGeneric("rowMedians"))
setGeneric("colMeans", function(x,na.rm = FALSE, dims = 1L,...) standardGeneric("colMeans"))
setGeneric("colSums", function(x,na.rm = FALSE, dims = 1L,...) standardGeneric("colSums"))
setGeneric("colVars", function(x,na.rm = FALSE, dims = 1) standardGeneric("colVars"))
setGeneric("colSd", function(x,na.rm = FALSE, dims = 1) standardGeneric("colSd"))
setGeneric("colMax", function(x,na.rm = FALSE, dims = 1) standardGeneric("colMax"))
setGeneric("colMin", function(x,na.rm = FALSE, dims = 1) standardGeneric("colMin"))
setGeneric("colMedians", function(x,na.rm = FALSE) standardGeneric("colMedians"))
setGeneric("colRanges", function(x,na.rm = FALSE) standardGeneric("colRanges"))
setGeneric("colApply", function(x,...) standardGeneric("colApply"))
setGeneric("rowApply", function(x,...) standardGeneric("rowApply"))
setGeneric("subBufferedMatrix", function(x,...) standardGeneric("subBufferedMatrix"))
setGeneric("rownames", function(x,do.NULL=TRUE,prefix="row") standardGeneric("rownames"))
setGeneric("colnames", function(x,do.NULL=TRUE,prefix="col") standardGeneric("colnames"))
setGeneric("colnames<-", function(x,value) standardGeneric("colnames<-"))
setGeneric("rownames<-", function(x,value) standardGeneric("rownames<-"))
setGeneric("ReadOnlyMode", function(x) standardGeneric("ReadOnlyMode"))
setGeneric("is.ReadOnlyMode", function(x) standardGeneric("is.ReadOnlyMode"))
setGeneric("memory.usage",function(x) standardGeneric("memory.usage"))
setGeneric("disk.usage",function(x) standardGeneric("disk.usage"))
setGeneric("AddColumn",function(x) standardGeneric("AddColumn"))
setGeneric("MoveStorageDirectory",function(x,new.directory,...) standardGeneric("MoveStorageDirectory"))

library(BufferedMatrix);library.dynam("BufferedMatrix","BufferedMatrix", .libPaths());


### this is used to control how many repetitions in something below
### higher values result in more checks.
nreps <-100 ##20000


## test creation and some simple assignments and subsetting operations

## first on single elements
tmp <- createBufferedMatrix(1000,10)

tmp[10,5]
tmp[10,5] <- 10
tmp[10,5]
tmp[10,5] <- 12.445
tmp[10,5]



## now testing accessing multiple elements
tmp2 <- createBufferedMatrix(10,20)


tmp2[3,1] <- 51.34
tmp2[9,2] <- 9.87654
tmp2[,1:2]
tmp2[,-(3:20)]
tmp2[3,]
tmp2[-3,]
tmp2[2,1:3]
tmp2[3:9,1:3]
tmp2[-4,-4]

## now testing accessing/assigning multiple elements
tmp3 <- createBufferedMatrix(10,10)

for (i in 1:10){
  for (j in 1:10){
    tmp3[i,j] <- (j-1)*10 + i
  }
}

tmp3[2:4,2:4]
tmp3[c(-10),c(2:4,2:4,10,1,2,1:10,10:1)]
tmp3[-c(1:5),-c(6:10)]

## assignment of whole columns
tmp3[,1] <- c(1:10*100.0)
tmp3[,1:2] <- tmp3[,1:2]*100
tmp3[,1:2] <- tmp3[,2:1]
tmp3[,1:2]


tmp3[,-1] <- tmp3[,1:9]
tmp3[,1:10]

tmp3[,1:2] <- rep(1,10)
tmp3[,1:2] <- rep(1,20)
tmp3[,1:2] <- matrix(c(1:5),1,5)

tmp3[,-c(1:8)] <- matrix(c(1:5),1,5)

tmp3[1,] <- 1:10
tmp3[1,]
tmp3[-1,] <- c(1,2)
tmp3[1:10,]
tmp3[-c(1:8),] <- matrix(c(1:5),1,5)
tmp3[1:10,]


tmp3[1:2,1:2] <- 5555.04
tmp3[-(1:2),1:2] <- 1234.56789



## testing accessors for the directory and prefix
directory(tmp3)
prefix(tmp3)

## testing if we can remove these objects
rm(tmp, tmp2, tmp3)
gc()




##
## checking reads
##

tmp2 <- createBufferedMatrix(10,20)

test.sample <- rnorm(10*20)

tmp2[1:10,1:20] <- test.sample

test.matrix <- matrix(test.sample,10,20)

## testing reads
for (rep in 1:nreps){
  which.row <- sample(1:10,1)
  which.col <- sample(1:20,1)
  if (tmp2[which.row,which.col] != test.matrix[which.row,which.col]){
    cat("incorrect agreement")
    break;
  }
}


for (rep in 1:nreps){
  which.row <- sample(1:10,1)
  if (!all(tmp2[which.row,] == test.matrix[which.row,])){
    cat("incorrect agreement")
    break;
  }
}


for (rep in 1:nreps){
  which.col <- sample(1:20,1)
  if (!all(tmp2[,which.col] == test.matrix[,which.col])){
    cat("incorrect agreement")
    break;
  }
}



for (rep in 1:nreps){
  which.col <- sample(1:10,5,replace=TRUE)
  if (!all(tmp2[,which.col] == test.matrix[,which.col])){
    cat("incorrect agreement")
    break;
  }
}


date()
for (rep in 1:nreps){
  which.row <- sample(1:10,5,replace=TRUE)
  if (!all(tmp2[which.row,] == test.matrix[which.row,])){
    cat("incorrect agreement")
    break;
  }
}
date()


for (rep in 1:nreps){
  which.row <- sample(1:10,5,replace=TRUE)
  which.col <- sample(1:10,5,replace=TRUE)
  if (!all(tmp2[which.row,which.col] == test.matrix[which.row,which.col])){
    cat("incorrect agreement")
    break;
  }
}





RowMode(tmp2)



for (rep in 1:nreps){
  which.row <- sample(1:10,1)
  which.col <- sample(1:20,1)
  if (tmp2[which.row,which.col] != test.matrix[which.row,which.col]){
    cat("incorrect agreement")
    break;
  }
}


for (rep in 1:nreps){
  which.row <- sample(1:10,1)
  if (!all(tmp2[which.row,] == test.matrix[which.row,])){
    cat("incorrect agreement")
    break;
  }
}


for (rep in 1:nreps){
  which.col <- sample(1:20,1)
  if (!all(tmp2[,which.col] == test.matrix[,which.col])){
    cat("incorrect agreement")
    break;
  }
}



for (rep in 1:nreps){
  which.col <- sample(1:20,5,replace=TRUE)
  if (!all(tmp2[,which.col] == test.matrix[,which.col])){
    cat("incorrect agreement")
    break;
  }
}



for (rep in 1:nreps){
  which.row <- sample(1:10,5,replace=TRUE)
  if (!all(tmp2[which.row,] == test.matrix[which.row,])){
    cat("incorrect agreement")
    break;
  }
}


date()
for (rep in 1:nreps){
  which.row <- sample(1:10,5,replace=TRUE)
  which.col <- sample(1:20,5,replace=TRUE)
  if (!all(tmp2[which.row,which.col] == test.matrix[which.row,which.col])){
    cat("incorrect agreement")
    break;
  }
}
date()

ColMode(tmp2)



### Now testing assignments

for (rep in 1:nreps){
  which.row <- sample(1:10,1)

  new.data <- rnorm(20)
  tmp2[which.row,] <- new.data
  test.matrix[which.row,] <- new.data
  if (rep > 1){
    if (!all(tmp2[prev.row,] == test.matrix[prev.row,])){
      cat("incorrect agreement")
      break;
    }
  }
  prev.row <- which.row
  
}





for (rep in 1:nreps){
  which.col <- sample(1:20,1)
  new.data <- rnorm(10)
  tmp2[,which.col] <- new.data
  test.matrix[,which.col]<- new.data

  if (rep > 1){
    if (!all(tmp2[,prev.col] == test.matrix[,prev.col])){
      cat("incorrect agreement")
      break;
    }
  }
  prev.col <- which.col
}





for (rep in 1:nreps){
  which.col <- sample(1:20,5,replace=TRUE)
  new.data <- matrix(rnorm(50),5,10)
  tmp2[,which.col] <- new.data
  test.matrix[,which.col]<- new.data
  
  if (rep > 1){
    if (!all(tmp2[,prev.col] == test.matrix[,prev.col])){
      cat("incorrect agreement")
      break;
    }
  }
  prev.col <- which.col
}



for (rep in 1:nreps){
  which.row <- sample(1:10,5,replace=TRUE)
  new.data <- matrix(rnorm(50),5,10)
  tmp2[which.row,] <- new.data
  test.matrix[which.row,]<- new.data
  
  if (rep > 1){
    if (!all(tmp2[prev.row,] == test.matrix[prev.row,])){
      cat("incorrect agreement")
      break;
    }
  }
  prev.row <- which.row
}





for (rep in 1:nreps){
  which.row <- sample(1:10,5,replace=TRUE)
  which.col  <- sample(1:20,5,replace=TRUE)
  new.data <- matrix(rnorm(25),5,5)
  tmp2[which.row,which.col] <- new.data
  test.matrix[which.row,which.col]<- new.data
  
  if (rep > 1){
    if (!all(tmp2[prev.row,prev.col] == test.matrix[prev.row,prev.col])){
      cat("incorrect agreement")
      break;
    }
  }
  prev.row <- which.row
  prev.col <- which.col
}




###
###
### testing some more functions
###



## duplication function
tmp5 <- duplicate(tmp2)

# making sure really did copy everything.
tmp5[1,1] <- tmp5[1,1] +100.00

if (tmp5[1,1] == tmp2[1,1]){
  stop("Problem with duplication")
}




### testing elementwise applying of functions

tmp5[1:4,1:4]
ewApply(tmp5,abs)
tmp5[1:4,1:4]
ewApply(tmp5,sqrt)
tmp5[1:4,1:4]

my.function <- function(x,power){
  (x+5)^power
}

ewApply(tmp5,my.function,power=2)
tmp5[1:4,1:4]



## testing functions that elementwise transform the matrix
sqrt(tmp5)
exp(tmp5)
log(tmp5,2)
pow(tmp5,2)





## testing functions that apply to entire matrix
Max(tmp5)
Min(tmp5)
mean(tmp5)
Sum(tmp5)
Var(tmp5)


## testing functions applied to rows or columns

rowMeans(tmp5)
rowSums(tmp5)
rowVars(tmp5)
rowSd(tmp5)
rowMax(tmp5)
rowMin(tmp5)

colMeans(tmp5)
colSums(tmp5)
colVars(tmp5)
colSd(tmp5)
colMax(tmp5)
colMin(tmp5)


### setting a random element to NA and then testing with na.rm=TRUE or na.rm=FALSE (The default)


which.row <- sample(1:10,1,replace=TRUE)
which.col  <- sample(1:20,1,replace=TRUE)

tmp5[which.row,which.col] <- NA

Max(tmp5)
Min(tmp5)
mean(tmp5)
Sum(tmp5)
Var(tmp5)

rowMeans(tmp5)
rowSums(tmp5)
rowVars(tmp5)
rowSd(tmp5)
rowMax(tmp5)
rowMin(tmp5)

colMeans(tmp5)
colSums(tmp5)
colVars(tmp5)
colSd(tmp5)
colMax(tmp5)
colMin(tmp5)

Max(tmp5,na.rm=TRUE)
Min(tmp5,na.rm=TRUE)
mean(tmp5,na.rm=TRUE)
Sum(tmp5,na.rm=TRUE)
Var(tmp5,na.rm=TRUE)

rowMeans(tmp5,na.rm=TRUE)
rowSums(tmp5,na.rm=TRUE)
rowVars(tmp5,na.rm=TRUE)
rowSd(tmp5,na.rm=TRUE)
rowMax(tmp5,na.rm=TRUE)
rowMin(tmp5,na.rm=TRUE)

colMeans(tmp5,na.rm=TRUE)
colSums(tmp5,na.rm=TRUE)
colVars(tmp5,na.rm=TRUE)
colSd(tmp5,na.rm=TRUE)
colMax(tmp5,na.rm=TRUE)
colMin(tmp5,na.rm=TRUE)

# now set an entire row to NA

tmp5[which.row,] <- NA
rowMeans(tmp5,na.rm=TRUE)
rowSums(tmp5,na.rm=TRUE)
rowVars(tmp5,na.rm=TRUE)
rowSd(tmp5,na.rm=TRUE)
rowMax(tmp5,na.rm=TRUE)
rowMin(tmp5,na.rm=TRUE)


# now set an entire col to NA


tmp5[,which.col] <- NA
colMeans(tmp5,na.rm=TRUE)
colSums(tmp5,na.rm=TRUE)
colVars(tmp5,na.rm=TRUE)
colSd(tmp5,na.rm=TRUE)
colMax(tmp5,na.rm=TRUE)
colMin(tmp5,na.rm=TRUE)




copymatrix <- matrix(rnorm(200,150,15),10,20)

tmp5[1:10,1:20] <- copymatrix
which.row <- 3
which.col  <- 1
cat(which.row," ",which.col,"\n")
tmp5[which.row,which.col] <- NA
copymatrix[which.row,which.col] <- NA

rowVars(tmp5,na.rm=TRUE)
apply(copymatrix,1,var,na.rm=TRUE)



copymatrix <- matrix(rnorm(200,150,15),10,20)

tmp5[1:10,1:20] <- copymatrix
which.row <- 1
which.col  <- 3
cat(which.row," ",which.col,"\n")
tmp5[which.row,which.col] <- NA
copymatrix[which.row,which.col] <- NA

colVars(tmp5,na.rm=TRUE)-apply(copymatrix,2,var,na.rm=TRUE)










## making sure these things agree
##
## first when there is no NA



agree.checks <- function(buff.matrix,r.matrix,err.tol=1e-10){

  if (Max(buff.matrix,na.rm=TRUE) != max(r.matrix,na.rm=TRUE)){
    stop("No agreement in Max")
  }
  

  if (Min(buff.matrix,na.rm=TRUE) != min(r.matrix,na.rm=TRUE)){
    stop("No agreement in Min")
  }


  if (abs(Sum(buff.matrix,na.rm=TRUE)- sum(r.matrix,na.rm=TRUE)) > err.tol){

    cat(Sum(buff.matrix,na.rm=TRUE),"\n")
    cat(sum(r.matrix,na.rm=TRUE),"\n")
    cat(Sum(buff.matrix,na.rm=TRUE) - sum(r.matrix,na.rm=TRUE),"\n")
    
    stop("No agreement in Sum")
  }
  
  if (abs(mean(buff.matrix,na.rm=TRUE) - mean(r.matrix,na.rm=TRUE)) > err.tol){
    stop("No agreement in mean")
  }
  
  
  if(abs(Var(buff.matrix,na.rm=TRUE) - var(as.vector(r.matrix),na.rm=TRUE)) > err.tol){
    stop("No agreement in Var")
  }
  
  

  if(any(abs(rowMeans(buff.matrix,na.rm=TRUE) - apply(r.matrix,1,mean,na.rm=TRUE)) > err.tol,na.rm=TRUE)){
    stop("No agreement in rowMeans")
  }
  
  
  if(any(abs(colMeans(buff.matrix,na.rm=TRUE) - apply(r.matrix,2,mean,na.rm=TRUE))> err.tol,na.rm=TRUE)){
    stop("No agreement in colMeans")
  }
  
  
  if(any(abs(rowSums(buff.matrix,na.rm=TRUE)  -  apply(r.matrix,1,sum,na.rm=TRUE))> err.tol,na.rm=TRUE)){
    stop("No agreement in rowSums")
  }
  
  
  if(any(abs(colSums(buff.matrix,na.rm=TRUE) - apply(r.matrix,2,sum,na.rm=TRUE))> err.tol,na.rm=TRUE)){
    stop("No agreement in colSums")
  }
  
  ### this is to get around the fact that R doesn't like to compute NA on an entire vector of NA when 
  ### computing variance
  my.Var <- function(x,na.rm=FALSE){
   if (all(is.na(x))){
     return(NA)
   } else {
     var(x,na.rm=na.rm)
   }

  }
  
  if(any(abs(rowVars(buff.matrix,na.rm=TRUE) - apply(r.matrix,1,my.Var,na.rm=TRUE))  > err.tol,na.rm=TRUE)){
    stop("No agreement in rowVars")
  }
  
  
  if(any(abs(colVars(buff.matrix,na.rm=TRUE) - apply(r.matrix,2,my.Var,na.rm=TRUE))  > err.tol,na.rm=TRUE)){
    stop("No agreement in rowVars")
  }


  if(any(abs(rowMax(buff.matrix,na.rm=TRUE) - apply(r.matrix,1,max,na.rm=TRUE))  > err.tol,na.rm=TRUE)){
    stop("No agreement in colMax")
  }
  

  if(any(abs(colMax(buff.matrix,na.rm=TRUE) - apply(r.matrix,2,max,na.rm=TRUE))  > err.tol,na.rm=TRUE)){
    stop("No agreement in colMax")
  }
  
  
  
  if(any(abs(rowMin(buff.matrix,na.rm=TRUE) - apply(r.matrix,1,min,na.rm=TRUE))  > err.tol,na.rm=TRUE)){
    stop("No agreement in colMin")
  }
  

  if(any(abs(colMin(buff.matrix,na.rm=TRUE) - apply(r.matrix,2,min,na.rm=TRUE))  > err.tol,na.rm=TRUE)){
    stop("No agreement in colMin")
  }

  if(any(abs(colMedians(buff.matrix,na.rm=TRUE) - apply(r.matrix,2,median,na.rm=TRUE)) > err.tol,na.rm=TRUE)){
    stop("No agreement in colMedian")
  }

  if(any(abs(colRanges(buff.matrix,na.rm=TRUE) - apply(r.matrix,2,range,na.rm=TRUE)) > err.tol,na.rm=TRUE)){
    stop("No agreement in colRanges")
  }


  
}









for (rep in 1:20){
  copymatrix <- matrix(rnorm(200,150,15),10,20)
  
  tmp5[1:10,1:20] <- copymatrix


  agree.checks(tmp5,copymatrix)
  
  ## now lets assign some NA values and check agreement

  which.row <- sample(1:10,1,replace=TRUE)
  which.col  <- sample(1:20,1,replace=TRUE)
  
  cat(which.row," ",which.col,"\n")
  
  tmp5[which.row,which.col] <- NA
  copymatrix[which.row,which.col] <- NA
  
  agree.checks(tmp5,copymatrix)

  ## make an entire row NA
  tmp5[which.row,] <- NA
  copymatrix[which.row,] <- NA


  agree.checks(tmp5,copymatrix)
  
  ### also make an entire col NA
  tmp5[,which.col] <- NA
  copymatrix[,which.col] <- NA

  agree.checks(tmp5,copymatrix)

  ### now make 1 element non NA with NA in the rest of row and column

  tmp5[which.row,which.col] <- rnorm(1,150,15)
  copymatrix[which.row,which.col] <- tmp5[which.row,which.col]

  agree.checks(tmp5,copymatrix)
}


### now test 1 by n and n by 1 matrix


err.tol <- 1e-12

rm(tmp5)

dataset1 <- rnorm(100)
dataset2 <- rnorm(100)

tmp <- createBufferedMatrix(1,100)
tmp[1,] <- dataset1

tmp2 <- createBufferedMatrix(100,1)
tmp2[,1] <- dataset2





Max(tmp)
Min(tmp)
mean(tmp)
Sum(tmp)
Var(tmp)

rowMeans(tmp)
rowSums(tmp)
rowVars(tmp)
rowSd(tmp)
rowMax(tmp)
rowMin(tmp)

colMeans(tmp)
colSums(tmp)
colVars(tmp)
colSd(tmp)
colMax(tmp)
colMin(tmp)
colMedians(tmp)
colRanges(tmp)


Max(tmp2)
Min(tmp2)
mean(tmp2)
Sum(tmp2)
Var(tmp2)

rowMeans(tmp2)
rowSums(tmp2)
rowVars(tmp2)
rowSd(tmp2)
rowMax(tmp2)
rowMin(tmp2)

colMeans(tmp2)
colSums(tmp2)
colVars(tmp2)
colSd(tmp2)
colMax(tmp2)
colMin(tmp2)
colMedians(tmp2)
colRanges(tmp2)

dataset1 <- matrix(dataset1,1,100)

agree.checks(tmp,dataset1)

dataset2 <- matrix(dataset2,100,1)
agree.checks(tmp2,dataset2)
  

tmp <- createBufferedMatrix(10,10)

tmp[1:10,1:10] <- rnorm(100)
colApply(tmp,sum)
colApply(tmp,quantile)[,1]

rowApply(tmp,sum)
rowApply(tmp,rank)[1:10,]

tmp <- createBufferedMatrix(5,20)

tmp[1:5,1:20] <- rnorm(100)
colApply(tmp,sum)
colApply(tmp,quantile)[,1]

rowApply(tmp,sum)
rowApply(tmp,rank)[1:5,]


as.matrix(tmp)


is.BufferedMatrix(tmp)

as.BufferedMatrix(as.matrix(tmp))



subBufferedMatrix(tmp,1:5,1:5)
subBufferedMatrix(tmp,,5:8)
subBufferedMatrix(tmp,1:3,)


rm(tmp)


###
### Testing colnames and rownames
###

tmp <- createBufferedMatrix(5,20)
tmp[1:5,1:20] <- rnorm(100)


colnames(tmp)
rownames(tmp)


colnames(tmp) <- colnames(tmp,do.NULL=FALSE)
rownames(tmp) <- rownames(tmp,do.NULL=FALSE)

colnames(tmp)
rownames(tmp)


tmp["row1",]
tmp[,"col10"]
tmp[c("row1","row5"),]
tmp[,c("col6","col20")]
tmp[c("row1","row5"),c("col6","col20")]




tmp["row1",] <- rnorm(20,mean=10)
tmp[,"col10"] <- rnorm(5,mean=30)
tmp[c("row1","row5"),] <- rnorm(40,mean=50)
tmp[,c("col6","col20")] <- rnorm(10,mean=75)
tmp[c("row1","row5"),c("col6","col20")]  <- rnorm(4,mean=105)

tmp["row1",]
tmp[,"col10"]
tmp[c("row1","row5"),]
tmp[,c("col6","col20")]
tmp[c("row1","row5"),c("col6","col20")]


subBufferedMatrix(tmp,c("row1","row5"),c("col6","col20"))[1:2,1:2]





tmp <- createBufferedMatrix(5,20)
tmp[1:5,1:20] <- rnorm(100)
colnames(tmp) <- colnames(tmp,do.NULL=FALSE)

tmp[,"col13"]
tmp[,c("col17","col7")]

subBufferedMatrix(tmp,,c("col6","col20"))[,1:2]
subBufferedMatrix(tmp,1,c("col6"))[,1]
subBufferedMatrix(tmp,1:2,c("col6"))[,1]



tmp <- createBufferedMatrix(5,20)
tmp[1:5,1:20] <- rnorm(100)
rownames(tmp) <- rownames(tmp,do.NULL=FALSE)




subBufferedMatrix(tmp,c("row3","row1"),)[,1:20]
subBufferedMatrix(tmp,c("row2"),1:10)[,1:10]
subBufferedMatrix(tmp,c("row5"),1:20)[,1:20]


colnames(tmp) <- colnames(tmp,do.NULL=FALSE)
rownames(tmp) <- rownames(tmp,do.NULL=FALSE)

colnames(tmp)
rownames(tmp)


colnames(tmp) <- NULL
rownames(tmp) <- NULL

colnames(tmp)
rownames(tmp)


colnames(tmp) <- colnames(tmp,do.NULL=FALSE)
rownames(tmp) <- rownames(tmp,do.NULL=FALSE)

dimnames(tmp)

dimnames(tmp) <- NULL

colnames(tmp) <- colnames(tmp,do.NULL=FALSE)
dimnames(tmp)


dimnames(tmp) <- NULL
rownames(tmp) <- rownames(tmp,do.NULL=FALSE)
dimnames(tmp)

dimnames(tmp) <- list(NULL,c(colnames(tmp,do.NULL=FALSE)))
dimnames(tmp)



###
### Testing logical indexing
###
###

tmp <- createBufferedMatrix(230,15)
tmp[1:230,1:15] <- rnorm(230*15)
x <-tmp[1:230,1:15]  

for (rep in 1:10){
  which.cols <- sample(c(TRUE,FALSE),15,replace=T)
  which.rows <- sample(c(TRUE,FALSE),230,replace=T)
  
  if (!all(tmp[which.rows,which.cols] == x[which.rows,which.cols])){
    stop("No agreement when logical indexing\n")
  }
  
  if (!all(subBufferedMatrix(tmp,,which.cols)[,1:sum(which.cols)] ==  x[,which.cols])){
    stop("No agreement when logical indexing in subBufferedMatrix cols\n")
  }
  if (!all(subBufferedMatrix(tmp,which.rows,)[1:sum(which.rows),] ==  x[which.rows,])){
    stop("No agreement when logical indexing in subBufferedMatrix rows\n")
  }
  
  
  if (!all(subBufferedMatrix(tmp,which.rows,which.cols)[1:sum(which.rows),1:sum(which.cols)]==  x[which.rows,which.cols])){
    stop("No agreement when logical indexing in subBufferedMatrix rows and columns\n")
  }
}


##
## Test the ReadOnlyMode
##

ReadOnlyMode(tmp)
is.ReadOnlyMode(tmp)

filenames(tmp)


### testing coercion functions
###

tmp <- as(tmp,"matrix")
tmp <- as(tmp,"BufferedMatrix")



### testing whether can move storage from one location to another

MoveStorageDirectory(tmp,"NewDirectory",full.path=FALSE)
MoveStorageDirectory(tmp,getwd(),full.path=TRUE)


RowMode(tmp)
rowMedians(tmp)

%\VignetteIndexEntry{BufferedMatrix: Introduction}
%\VignettePackage{BufferedMatrix}
\documentclass[12pt]{article}
\usepackage{amsmath}
\usepackage{hyperref}
\usepackage[authoryear,round]{natbib}

\textwidth=6.2in
\textheight=8.5in
%\parskip=.3cm
\oddsidemargin=.1in
\evensidemargin=.1in
\headheight=-.3in


\newcommand\Rpackage[1]{{\textsf{#1}\index{#1 (package)}}}
\newcommand\dataset[1]{{\textit{#1}\index{#1 (data set)}}}
\newcommand\Rclass[1]{{\textit{#1}\index{#1 (class)}}}
\newcommand\Rfunction[1]{{{\small\texttt{#1}}\index{#1 (function)}}}
\newcommand\Rfunarg[1]{{\small\texttt{#1}}}
\newcommand\Robject[1]{{\small\texttt{#1}}}


\newcommand{\scscst}{\scriptscriptstyle}
\newcommand{\scst}{\scriptstyle}
\author{Ben Bolstad \\ {\tt bmb@bmbolstad.com} \\ \url{http://bmbolstad.com}}
\begin{document}
\title{BufferedMatrix: Introduction}
\maketitle
\tableofcontents
\section{Introduction}

This document is intended to introduce the \Rpackage{BufferedMatrix} package and how it may be used. It is very important to know that this package provides infrastructure rather than an analysis methods as most other BioConductor packages do.  It is {\b not} intended to be used directly by end-users. Instead it is aimed at developers of other packages. The main purpose of this package is to provide the BufferedMatrix object. This document will explain how to use the BufferedMatrix object at the R level. There is also a C language interface to dealing with BufferedMatrix objects, but that will not be discussed here.

\section{What is a BufferedMatrix?}

A \Rclass{BufferedMatrix} object stores numerical data in a tabular format, with most of the data primarily stored outside main memory on the file system. Figure \ref{BM-WhatIs} shows that a BufferedMatrix consists of data values arranged in rows and columns. The BufferedMatrix object implemented in this package is optimized for situations where the number of rows in much larger than the number of columns. The word {\it Buffered} is used because frequently used parts of the BufferedMatrix may be kept in main memory for increased speed. It is intended that users of the BufferedMatrix will be unaware of what is and is not in memory. Note that although the word {\it Matrix} is part of the name of the object it does not imply that you may treat a BufferedMatrix object exactly like a Matrix in all situations. For instance \Rclass{BufferedMatrix} objects are passed by reference rather than by value, are not designed for using with Matrix algebra and can not automatically be passed to all pre-existing functions that expect ordinary matrices (particularly functions that use C code). More details about these issues will be discussed a little later in this document.

But first it is time to explore how to use the package. As with other packages we use \Rfunction{library} to load the package.
<<>>=
library(BufferedMatrix)
@




\begin{figure}[htbp]
\begin{center}
\includegraphics[width=1\textwidth]{BufferedMatrixPicture1}
\end{center}
\caption{\label{BM-WhatIs}A BufferedMatrix stores data values in tabular format. In the figures the dashed lines means that the data is stored outside main memory on the filesystem}
\end{figure}

To create a BufferedMatrix we use the \Rfunction{createBufferedMatrix} function. This function takes up to six arguments, but only the first one must be provided. To start with use:
<<>>=
X <- createBufferedMatrix(10000)
@
to create a BufferedMatrix with 10000 rows and 0 columns. Notice how only the number of rows must be supplied when creating a \Rclass{BufferedMatrix}. This is because BufferedMatrix objects fix the number of Rows they store, but allow you to dynamically add columns when needed. It is not possible however to remove columns from a BufferedMatrix. Just like all R objects typing the name of the object will show you some basic information (or the contents) of the object. In this case
<<>>=
X
@
Notice that basic summary information about the matrix is displayed in this case. We will discuss what this information means a little later. We could use the \Rfunction{AddColumn} function to add columns to our matrix like this
<<>>=
AddColumn(X)
AddColumn(X)
X
@

Of course it might have been more convinent just to instantiate our \Rclass{BufferedMatrix} object from the beginning as having 10000 rows and 2 columns. This would be acomplished using
<<>>=
X <- createBufferedMatrix(10000,2)
@

Of course \Rclass{BufferedMatrix} objects use buffers to temporarily store some of its contents in main memory, rather than on the filesystem. There are two types of buffering provided by BufferedMatrix objects. This are {\it ColMode} and {\it RowMode}. The default mode when you create a BufferedMatrix is to be in ColMode. Figure \ref{BM-ColMode} demonstrates the situation in ColMode. Specifically, the entire contents of a given number of columns are stored completely in RAM, with the rest of the data remaining on the file system. There is no requirement that these columns be contiguous. When most of your operations are to be done in a column-wise manner it is more efficient to be in ColMode.


\begin{figure}[htbp]
\begin{center}
\includegraphics[width=1\textwidth]{BufferedMatrixPicture2}
\end{center}
\caption{\label{BM-ColMode}Column Buffers hold selected columns in RAM. This speeds up access to data. Column Buffers are always active}
\end{figure}

The other main buffering mode is RowMode. Figure \ref{BM-RowMode} illustrates the situation when in RowMode. Note that when in row mode a block of contiguous rows across all columns of the BufferedMatrix is kept in main memory. RowMode is designed for situations where you need to access a fixed set of closely spaced rows of the matrix. Note that RowMode is considered a secondary buffering mode and that the column buffers are also present when in this mode.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=1\textwidth]{BufferedMatrixPicture3}
\end{center}
\caption{\label{BM-RowMode}Row Buffers hold a selected contiguous block of rows in RAM. Row Buffers exist only when the BufferedMatrix is in RowMode.}
\end{figure}

As previously mentioned before, all \Rclass{BufferedMatrix} objects start in ColMode. To switch to RowMode you can use the \Rfunction{RowMode} function like this:
<<>>=
RowMode(X)
@
To switch back to ColMode use
<<>>=
ColMode(X)
@


When you create the BufferedMatrix you can control the size of these Buffers in terms of number of columns or number of rows. In particular, suppose we wanted a 10000 by 5 matrix with 1 column buffered and 500 rows buffered when in row mode, this could be done by
<<>>=
X <- createBufferedMatrix(10000,5,bufferrows=500,buffercols=1)
@
You can also use \Rfunction{set.buffer.dim} function to set or change these after the matrix has been create. For instance to change it to 2 columns buffered and 100 rows use:
<<>>=
set.buffer.dim(X,100,2)
@

There are two additional arguments to \Rfunction{createBufferedMatrix}. The first is \Rfunarg{prefix} which is a string that will be used to start each temporary file name used for the filesystem storage of the \Rclass{BufferedMatrix}, by default this is "BM". The second is \Rfunarg{directory} which specifies where these temporary files are to be stored. By default this directory is the current working directory.

There are several functions to get this, and additional, information about an already created \Rclass{BufferedMatrix}.
<<>>=
memory.usage(X)
disk.usage(X)
nrow(X)
ncol(X)
dim(X)
buffer.dim(X)
prefix(X)
directory(X)
is.RowMode(X)
is.ColMode(X)
@

There is one other important mode that you may switch a \Rclass{BufferedMatrix} in and out of. This is {\it ReadOnly} mode. What this means is that you can access data values stored in the matrix but you can not change them. This provides speed-up in some situations because the current buffer does not need to be flushed out to the filesystem when an attempt is made to access a value currently not stored in the buffer. The function \Rfunction{ReadOnlyMode} is used to toggle between the two states.
<<>>=
ReadOnlyMode(X)
is.ReadOnlyMode(X)
ReadOnlyMode(X)
is.ReadOnlyMode(X)
@ 



\section{Accessing and Manipulating data stored within a BufferedMatrix}

Data is accessed from \Rclass{BufferedMatrix} objects using similar indexing procedures to those you would use with a standard \Rclass{matrix} object. In particular you can use the \Rfunction{[} aind \Rfunction{[<-} operators to see or replace data in an Buffered Matrix. Figure \ref{BM-IndexingMatrix} demonstrates how indexing and assigment operations are set up to occur with \Rclass{BufferedMatrix} objects. Specifically, when you index part of the BufferedMatrix an ordinary R matrix is created and the the data requested copied from the BufferedMatrix. This matrix is then no longer linked to the data in the BufferedMatrix.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=1\textwidth]{BufferedMatrixPicture4}
\end{center}
\caption{\label{BM-IndexingMatrix}Subsetting operators pull data out of the BufferedMatrix object and into R matrix objects or vice versa.}
\end{figure}

For example
<<>>=
X <- createBufferedMatrix(20,2)
X[1:20,] <- 1:40
B <- X[1:5,]
B
B[1:2,] <- B[1:2,]^2
B
X[1:5,]
@

Similarly, assignments using the indexing operators copy the data from the R \Rclass{matrix} or \Rclass{vector} into the specified location of the \Rclass{BufferedMatrix}. 
<<>>=
X[1:5,] <- B
X[1:5,]
@

As with ordinary R \Rclass{matrix} objects we may have column or row name indices. For example:
<<>>=
rownames(X)
colnames(X)
rownames(X) <- letters[1:20]
colnames(X) <- month.abb[1:2]
@ 
and these can be used interchangably with numerical indexing values.
<<>>=
X[c("a","b"),"Jan"]
X["t",2] <- 0
@

\Rclass{BufferedMatrix} objects also support logical indexing. eg
<<>>=
X[rep(c(TRUE,FALSE),10),1]
@

Sometimes it might be useful to create another \Rclass{BufferedMatrix} out of an existing one. For this purpose the \Rfunction{subBufferedMatrix} command may be used. This function operates in a similar manner to indexing operators, but instead of copying the data into an R matrix another \Robject{BufferedMatrix} is produced. Figure \ref{BM-subBufferedMatrix} illustates this procedure.

\begin{figure}[htbp]
\begin{center}
\includegraphics[width=1\textwidth]{BufferedMatrixPicture5}
\end{center}
\caption{\label{BM-subBufferedMatrix}Using subBufferedMatrix creates a new BufferedMatrix containing a subset of the data stored in the BufferedMatrix}
\end{figure}

<<>>=
Y <- subBufferedMatrix(X,1:5,1:2)
Y
@


\section{Functions for summarizing a BufferedMatrix}

Sometimes it is useful to generate summary statistic values from a \Rclass{BufferedMatrix} object. While it would be possible to do this by writing your own code using loops and indexing a number of more optimized functions have been provided for this purpose. These functions concentrate on getting the maximum, minimum, means, variances and so forth. The try to minimize buffer misses as much as possible.
<<>>=
X <- createBufferedMatrix(10,3)
X[1:10,] <- (1:30)^2
Max(X)
Min(X)
mean(X)
Sum(X)
Var(X)
Sd(X)
@

It may also be useful to get these values for each column or each row.
<<>>=
rowMeans(X)
colMeans(X)
rowSums(X)
colSums(X)
rowVars(X)
colVars(X)
rowSd(X)
colSd(X)
rowMax(X)
colMax(X)
rowMin(X)
colMin(X)
@

\section{Applying your own function to the rows or columns of a BufferedMatrix}

While many useful functions are provided for carrying out row-wise or column-wise operations,  you may want to use your own function to do a different summarization. This may be done using the \Rfunction{rowApply} and \Rfunction{colApply} functions. For example suppose you wanted to write a function which computed the sum of the cube roots of the elements of a column. This would be done like this:
<<>>=
sum.cube.root <- function(x){
	sum(x^(1/3))
}
colApply(X,sum.cube.root)
@
these functions may also take additional arguments
<<>>=
sum.arbitrary.power <- function(x,power=2){
	sum(x^power)
}
rowApply(X,sum.arbitrary.power,power=3)
@

Note that if your \Rclass{BufferedMatrix} is large and you are not in RowMode, with a sufficiently sized row buffer, then calls to \Rfunction{rowApply} will be very slow.

It is also possible to use a function which returns more than one item. In this case, rather than returning a vector another \Rclass{BufferedMatrix} will be returned.
<<>>=
Y <- colApply(X,sort,decreasing=TRUE)
is(Y,"BufferedMatrix")
@ 

Note that \Rfunction{colApply} and \Rfunction{rowApply} assume that your function returns a fixed length vector.


\section{Elementwise transformation of BufferedMatrix objects}

In some situations it might be useful to transform each element of your \Rclass{BufferedMatrix}. For instance log or exponential transformations, square roots or arbitrary powers. Unlike when you ordinarily apply these functions to an R matrix, when you apply these function to \Rclass{BufferedMatrix} objects, the object is not copied before being transformed. In otherwords these functions do not leave the \Rclass{BuffferedMatrix} untouched.
<<>>=
exp(X)
log(X)
sqrt(X)
pow(X,2.0)
@ 

If you have a customized function that you want to apply in an element-wise fashion you can use the \Rfunction{ewApply} function. Note that the function you supply must return only a single value when it is given an argument of length 1 and must return a vector of length $n$ if given a vector of length $n$. It is best that you design your input function to operate in a vectorized manner.
<<>>=
my.function <- function(x){
  x^2 +3*abs(x) - 9
}
ewApply(X, my.function)
@ 

\section{Converting between BufferedMatrix and Matrix objects}

It is possible to convert a \Rclass{BufferedMatrix} into a \Rclass{matrix} and vice versa. But in most cases you will not want to do this because your \Rclass{BufferedMatrix} may be too large to keep completely in the RAM available to R.

To convert a \Rclass{BufferedMatrix} to a \Rclass{Matrix} use:
<<>>=
Z <- as(X,"matrix")
class(Z)
@ 

To make a \Rclass{Matrix} become a \Rclass{BufferedMatrix} use:
<<>>=
A <- as(Z,"BufferedMatrix")
class(A)
@ 

\section{BufferedMatrix objects are pass-by reference}

As previously mentioned when you pass an \Rclass{BufferedMatrix} to a function you are passing it by reference. This means that if the function operates on the \Rclass{BufferedMatrix} using a function that can change values stored within the \Rclass{BufferedMatrix} then it is changed in the calling environment. This differs from the behaviour of a normal R matrix.
<<>>=
X <- createBufferedMatrix(50,10)
X[1:50,] <- 1:500
Y <- as(X,"matrix")

my.function <- function(a.matrix){
  a.matrix[,1:10] <- a.matrix[,sample(1:10,10)] 
}

X[1:5,]
my.function(X)
X[1:5,]

Y[1:5,]
my.function(Y)
Y[1:5,]
@ 

There is one exception to the pass-by reference rule, column and row names are passed by value, meaning that modifications to dimension names within a calling function have no effect on the dimension names in the calling environment. However, this may be changed in future releases so you should not rely on this behaviour.

In situations where you want to simulate call by value you can use the \Rfunction{duplicate} function. This will make a copy of the \Rclass{BufferedMatrix}.

<<>>=
X <- createBufferedMatrix(50,10)
X[1:50,] <- 1:500
my.function <- function(my.bufmat){
  internal.bufmat <- duplicate(my.bufmat)
  internal.bufmat[,1:10] <- internal.bufmat[,sample(1:10,10)] 
}


X[1:5,]
my.function(X)
X[1:5,]
@ 

Table \ref{BM-Modify} summarizes which functions modify and those don't modify \Rclass{BufferedMatrix} objects.


\begin{table}
\begin{center}
\begin{tabular}{|l|l|} \hline
Functions that do not & Functions that do \\
modify data stored in & modify data stored in \\
\Rclass{BufferedMatrix} objects & \Rclass{BufferedMatrix} objects \\ \hline
\Rfunction{[} & \Rfunction{[<-}\\
\Rfunction{Max} &    \Rfunction{exp}             \\
\Rfunction{Min} &   \Rfunction{log}                 \\
\Rfunction{mean} &  \Rfunction{sqrt}             \\
\Rfunction{Sum} &   \Rfunction{pow}      \\
\Rfunction{Var} &   \Rfunction{ewApply}      \\
\Rfunction{Sd} &     \Rfunction{RowMode}   \\  
\Rfunction{rowMeans} & \Rfunction{ColMode}\\
\Rfunction{colMeans} & \Rfunction{ReadOnlyMode}\\
\Rfunction{rowSums} & \Rfunction{AddColumn}\\
\Rfunction{colSums} & \\
\Rfunction{rowVars} &\\
\Rfunction{colVars} &                 \\
\Rfunction{rowSd} &                 \\
\Rfunction{colSd} &                 \\
\Rfunction{rowMax} &                 \\
\Rfunction{colMax} &                 \\
\Rfunction{rowMin} &                 \\
\Rfunction{colMin} &                 \\
\Rfunction{colApply} &                 \\
\Rfunction{rowApply} &                 \\
\Rfunction{duplicate} &   \\
\Rfunction{as} & \\
 \Rfunction{ncol}& \\
 \Rfunction{nrow}& \\
 \Rfunction{is.ColMode}& \\
 \Rfunction{is.RowMode}& \\
 \Rfunction{set.buffer.dim}& \\
 \Rfunction{prefix}& \\
 \Rfunction{directory}& \\
 \Rfunction{filenames}& \\
 \Rfunction{subBufferedMatrix}& \\
 \Rfunction{is.ReadOnlyMode} & \\
\Rfunction{memory.usage} & \\
\Rfunction{disk.usage} & \\ \hline
\end{tabular}
\end{center}
\caption{\label{BM-Modify}A breakdown of functions that do and do not modify data stored in or how it is stored in \Rclass{BufferedMatrix} objects.}
\end{table}



\section{Future Enhancements}

Currently \Rclass{BufferedMatrix} objects can not properly serialized. That means you can not save and reload a BufferedMatrix between R sessions. This is an issue to be addressed in a future release of the \Rpackage{BufferedMatrix} package.



\end{document}

\name{BufferedMatrix-class}
\docType{class}
\alias{BufferedMatrix-class}
\alias{buffer.dim}
\alias{set.buffer.dim}
\alias{ColMode}
\alias{RowMode}
\alias{is.ColMode}
\alias{is.RowMode}
\alias{prefix}
\alias{duplicate}
\alias{directory}
\alias{ewApply}
\alias{pow}

\alias{colMeans}
\alias{colSums}
\alias{rowMeans}
\alias{rowSums}

\alias{colMax}
\alias{colMin}
\alias{colSd}
\alias{colVars}
\alias{colMedians}
\alias{colRanges}
\alias{Max}
\alias{Min}
\alias{Sd}
\alias{Sum}
\alias{Var}
\alias{rowMax}
\alias{rowMin}
\alias{rowSd}
\alias{rowVars}
\alias{rowMedians}


\alias{colApply}
\alias{rowApply}

\alias{ReadOnlyMode}
\alias{is.ReadOnlyMode}
\alias{filenames}
\alias{disk.usage}
\alias{memory.usage}
\alias{AddColumn}
\alias{MoveStorageDirectory}
\alias{subBufferedMatrix}

\alias{dim,BufferedMatrix-method}
\alias{buffer.dim,BufferedMatrix-method}
\alias{nrow,BufferedMatrix-method}
\alias{ncol,BufferedMatrix-method}
\alias{[,BufferedMatrix-method}
\alias{[<-,BufferedMatrix-method}
\alias{show,BufferedMatrix-method}
\alias{set.buffer.dim,BufferedMatrix-method}
\alias{is.ColMode,BufferedMatrix-method}
\alias{is.RowMode,BufferedMatrix-method}
\alias{ColMode,BufferedMatrix-method}
\alias{RowMode,BufferedMatrix-method}
\alias{duplicate,BufferedMatrix-method}
\alias{prefix,BufferedMatrix-method}
\alias{directory,BufferedMatrix-method}
\alias{ewApply,BufferedMatrix-method}
\alias{exp,BufferedMatrix-method}
\alias{sqrt,BufferedMatrix-method}
\alias{pow,BufferedMatrix-method}
\alias{log,BufferedMatrix-method}

\alias{colMax,BufferedMatrix-method}
\alias{rowMax,BufferedMatrix-method}
\alias{colMeans,BufferedMatrix-method}
\alias{rowMeans,BufferedMatrix-method}
\alias{colMin,BufferedMatrix-method}
\alias{rowMin,BufferedMatrix-method}
\alias{colVars,BufferedMatrix-method}
\alias{rowVars,BufferedMatrix-method}
\alias{colSd,BufferedMatrix-method}
\alias{rowSd,BufferedMatrix-method}
\alias{colSums,BufferedMatrix-method}
\alias{rowSums,BufferedMatrix-method}
\alias{colMedians,BufferedMatrix-method}
\alias{rowMedians,BufferedMatrix-method}

\alias{colRanges,BufferedMatrix-method}


\alias{Max,BufferedMatrix-method}
\alias{Min,BufferedMatrix-method}
\alias{Var,BufferedMatrix-method}
\alias{Sd,BufferedMatrix-method}
\alias{Sum,BufferedMatrix-method}
\alias{mean,BufferedMatrix-method}

\alias{rowApply,BufferedMatrix-method}
\alias{colApply,BufferedMatrix-method}

\alias{as.matrix,BufferedMatrix-method}
\alias{subBufferedMatrix,BufferedMatrix-method}

\alias{colnames,BufferedMatrix-method}
\alias{rownames,BufferedMatrix-method}
\alias{colnames<-,BufferedMatrix-method}
\alias{rownames<-,BufferedMatrix-method}

\alias{dimnames,BufferedMatrix-method}
\alias{dimnames<-,BufferedMatrix-method}

\alias{ReadOnlyMode,BufferedMatrix-method}
\alias{is.ReadOnlyMode,BufferedMatrix-method}
\alias{filenames,BufferedMatrix-method}
\alias{disk.usage,BufferedMatrix-method}
\alias{memory.usage,BufferedMatrix-method}

\alias{coerce,matrix,BufferedMatrix-method}
\alias{coerce,BufferedMatrix,matrix-method}

\alias{AddColumn,BufferedMatrix-method}

\alias{MoveStorageDirectory,BufferedMatrix-method}



\title{Class BufferedMatrix}

\description{This is a class representation of a buffered matrix (of
  numeric data). In
  this case data is primarily stored outide main memory in temporary files.}
\section{Objects from the Class}{
  Objects can be created using the function \code{\link{createBufferedMatrix}}}
\section{Slots}{
  \describe{
    \item{\code{rawBufferedMatrix}:}{a pointer to an external structure
      used to access and store the matrix data.}
    \item{\code{rownames}:}{rownames for the matrix.}
    \item{\code{colnames}:}{colnames for the matrix.}
  }
 
}


\section{Methods}{
  
\describe{
  \item{ncol}{\code{signature(object = "BufferedMatrix")}: Returns the number of columns in the matrix}
  \item{nrow}{\code{signature(object = "BufferedMatrix")}: Returns the number of rows in the matrix}
  \item{dim}{\code{signature(object = "BufferedMatrix")}: Returns the
    dimensions of the matrix}
  \item{buffer.dim}{\code{signature(object = "BufferedMatrix")}: Returns
    the number of columns and the number of rows to be stored in the
    buffer}
  \item{set.buffer.dim}{\code{signature(object = "BufferedMatrix")}:
    Set the buffer size or resize it
  }

  \item{[}{\code{signature(object = "BufferedMatrix")}: matrix accessor}


  \item{[<-}{\code{signature(object = "BufferedMatrix")}: matrix
    replacer}
  \item{show}{\code{signature(object = "BufferedMatrix")}: prints basic
    information about the BufferedMatrix out to screen}

  \item{is.RowMode}{\code{signature(object = "BufferedMatrix")}:
    returns \code{TRUE} if the row buffer is active and \code{FALSE} otherwise.
  }
  \item{is.ColMode}{\code{signature(object = "BufferedMatrix")}:
    returns \code{TRUE} if the row buffer is inactive and \code{FALSE} otherwise.
  }
  \item{RowMode}{\code{signature(object = "BufferedMatrix")}:
    Activate the row buffer. 
  }
  \item{ColMode}{\code{signature(object = "BufferedMatrix")}:
    Deactivate the row buffer
  }

  \item{duplicate}{\code{signature(object = "BufferedMatrix")}:
    Make a copy of the BufferedMatrix
  }

  \item{prefix}{\code{signature(object = "BufferedMatrix")}:
    return the initial part of the string used for temporary files
  }

  \item{directory}{\code{signature(object = "BufferedMatrix")}:
    return the location where temporary files are stored
  }

  \item{filenames}{\code{signature(object = "BufferedMatrix")}:
    return the fully pathed filenames for each column in the matrix
  }

  
  \item{ewApply}{\code{signature(object = "BufferedMatrix")}:
    apply a function elementwise
  } 

  \item{exp}{\code{signature(object = "BufferedMatrix")}: Compute the
    exponential elementwise of the matrix
  }
  
  \item{sqrt}{\code{signature(object = "BufferedMatrix")}: Compute the
    square-root elementwise of the matrix
  } 

  \item{pow}{\code{signature(object = "BufferedMatrix")}:  Compute
    $x^{power}$ elementwise of the matrix
  }

  \item{log}{\code{signature(object = "BufferedMatrix")}:  Compute
    logarithm elementwise of the matrix
  }

  \item{colMax}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing maximums by column
  }

  \item{rowMax}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing maximums by row
  }

  
  \item{colMeans}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing means by column
  }
  
  \item{rowMeans}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing means by row
  }

  \item{colMin}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing minimums by column
  }


  \item{rowMin}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing minimums by row
  }

  \item{colVars}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing sample variances by column
  }

  \item{rowVars}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing sample variances by row
  }

  \item{colSd}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing sample standard deviations by column
  }

  \item{rowSd}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing sample standard deviations by row
  }

  \item{colSums}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing sum by column
  }

  \item{rowSums}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing sum by row
  }

  \item{colMedians}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing medians by column
  }

  \item{rowMedians}{\code{signature(object = "BufferedMatrix")}: Returns a
    vector containing medians by row. Best only used when the matrix is
    in RowMode (otherwise it is extremely slow)
  }
  \item{Max}{\code{signature(object = "BufferedMatrix")}: Returns the
    maximum of all elements in the matrix
  }
  
  \item{Min}{\code{signature(object = "BufferedMatrix")}: Returns the
    minimum of all elements in the matrix
  }

  \item{Var}{\code{signature(object = "BufferedMatrix")}: Returns the
    sample variance of all elements in the matrix
  }

  \item{Sd}{\code{signature(object = "BufferedMatrix")}: Returns the
    sample standard deviations of all elements in the matrix
  }
  
  \item{Sum}{\code{signature(object = "BufferedMatrix")}: Returns the
    sum of all elements in the matrix
  }

  \item{mean}{\code{signature(object = "BufferedMatrix")}: Returns the
    mean of all elements in the matrix
  }

  \item{colApply}{\code{signature(object = "BufferedMatrix")}:
    apply a function columnwise. Returns either a vector or BufferedMatrix.
  } 

  \item{rowApply}{\code{signature(object = "BufferedMatrix")}:
    apply a function row-wise. Returns either a vector or BufferedMatrix.
  } 

  \item{as.matrix}{\code{signature(object = "BufferedMatrix")}:
    coerce BufferedMatrix into a regular R \code{\link{matrix}}
  }

  \item{subBufferedMatrix}{\code{signature(object = "BufferedMatrix")}:
    gets data from BufferedMatrix and returns it in another
    BufferedMatrix
  }

  \item{rownames}{\code{signature(object = "BufferedMatrix")} : access
    the row names
  }

  \item{colnames}{\code{signature(object = "BufferedMatrix")} : access
    the column names
  }

  \item{rownames<-}{\code{signature(object = "BufferedMatrix")} : replace
    the row names
  }

  \item{colnames<-}{\code{signature(object = "BufferedMatrix")} : replace
    the column names
  }

  \item{dimnames}{\code{signature(object = "BufferedMatrix")} : Access
    the row and column names
  }

  \item{dimnames}{\code{signature(object = "BufferedMatrix")} : Replace
    the row and column names
  }


  \item{ReadOnlyMode}{\code{signature(object = "BufferedMatrix")} :
    Toggles the Read Only mode on and off
  }

  \item{is.ReadOnlyMode}{\code{signature(object = "BufferedMatrix")} :
    Finds out if it is in Read Only Mode
  }

  \item{memory.usage}{\code{signature(object = "BufferedMatrix")} :
    Give amount of RAM currently in use by BufferedMatrix object
  }

 \item{disk.usage}{\code{signature(object = "BufferedMatrix")} :
    Give amount of disk space currently in use by BufferedMatrix object
  }

  \item{\code{as(matrix,BufferedMatrix)}:}{Coerce \code{matrix} to \code{BufferedMatrix}.}
  \item{\code{as(BufferedMatrix,matrix)}:}{Coerce the \code{Buffered} to \code{matrix}.}


  \item{\code{AddColumn}:}{Add an additional column to the matrix. Will
    be all empty (set to 0)}

  \item{\code{MoveStorageDirectory}:}{Move the temporary files used to
  store the matrix from one location to another}
  
  
  }}




\author{B. M. Bolstad \email{bmb@bmbolstad.com}}

\keyword{classes}

\name{as.BufferedMatrix}
\alias{as.BufferedMatrix}
\alias{is.BufferedMatrix}
\title{Check or Coerce object to BufferedMatrix}
\description{'as.BufferedMatrix' will coerce the supplied object into a
  BufferedMatrix. 'is.BufferedMatrix' checks whether the supplied
  argument is a BufferedMatrix.
}
\usage{
 as.BufferedMatrix(x, bufferrows=1, buffercols=1,directory=getwd())
 is.BufferedMatrix(x)
}
\arguments{
  \item{x}{an R object}
  \item{bufferrows}{number of rows to be buffered if the row buffer is
    activated} 
  \item{buffercols}{number of columns to be buffered}
  \item{directory}{path to directory where temporary files should be stored}

}
\details{
  These functions are useful for converting between R
  \code{\link{matrix}} objects and
  \code{\link[BufferedMatrix:BufferedMatrix-class]{BufferedMatrix}} objects. 
}
\author{B. M. Bolstad <bmb@bmbolstad.com>}
\keyword{manip}

\name{createBufferedMatrix}
\alias{createBufferedMatrix}
\title{createBufferedMatrix}
\description{Creates a Buffered Matrix object}
\usage{createBufferedMatrix(rows, cols=0, bufferrows=1, buffercols=1,prefix="BM",directory=getwd())
}
\arguments{
  \item{rows}{Number of rows in the matrix}
  \item{cols}{Initial number of coulmns in the matrix}
  \item{bufferrows}{number of rows to be buffered if the row buffer is activated}
  \item{buffercols}{number of columns to be buffered}
  \item{prefix}{String to be used as start of name for any temporary files}
  \item{directory}{path to directory where temporary files should be stored}
}
\value{
}
\details{
}
\references{
}
\seealso{
}
\examples{
}
\author{B. M. Bolstad <bmb@bmbolstad.com>}
\keyword{}
